码迷,mamicode.com
首页 > 其他好文 > 详细

LeetCode-Find Peak Element

时间:2015-03-07 00:52:10      阅读:198      评论:0      收藏:0      [点我收藏+]

标签:

A peak element is an element that is greater than its neighbors.

Given an input array where num[i] ≠ num[i+1], find a peak element and return its index.

The array may contain multiple peaks, in that case return the index to any one of the peaks is fine.

You may imagine that num[-1] = num[n] = -∞.

For example, in array [1, 2, 3, 1], 3 is a peak element and your function should return the index number 2.

click to show spoilers.

Note:
Your solution should be in logarithmic complexity.

这题的关键是弄清楚为什么可以使用二分法。对于两端的节点,因为num[-1] = num[n] = -∞,所以只要数组中没有连续出现的相同元素,这个peak element就总是存在的。

二分查找所依据的关键,就是如果num[mid]<=num[mid-1],那么peak element一定存在于区间[low, mid-1];如果num[mid]<=num[mid+1],那么peak element一定存在于区间[mid+1, high].

 

public class Solution {
    public int findPeakElement(int[] num) {
        int len = num.length;
        if( len <= 1){
            return 0;
        }
        if(num[0] > num[1]){
            return 0;
        }
        if(num[len-1] > num[len-2]){
            return len-1;
        }
        
        int low = 0;
        int high = len-1;
        
        while(high>low){
            int mid = num[(low+high)/2];
            if( mid>num[(low+high)/2+1] && mid>num[(low+high)/2-1] ){
                return (low+high)/2;
            }
            else if(mid < num[(low+high)/2+1]){
                low = (low+high)/2;
                
            }
            
            else if(mid <num[(low+high)/2-1]){
                high = (low+high)/2;
            }
            
        }
        return -1;
        
        
    }
    
  
    
}

 

LeetCode-Find Peak Element

标签:

原文地址:http://www.cnblogs.com/incrediblechangshuo/p/4319589.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!